#
#   Copyright <=2004 by Immanuel Halupczok
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#


# Main Cuyo level description file

# To experiment with own levels, see the file example.ld

# The file docs/cual.6 (man -l docs/cual.6 or simply man cual) contains
# a desciption of Cual, the lanquage you will find in level description
# files between the << >>.



### Die Namen der Level in der Reihenfolge, wie sie im Spiel auftauchen

# Some of these levels are still under construction:
level=Nasenkugeln,Embroidery,ASCII,Baender,Pfeile,UnterWasser.u,
  Tiere,Rohrpost,HexKugeln,Slime,Explosive,
  Letters,SilberGold,Gold,DreiD,Disco,
  Wohnungen,Zahn,Baggis,Kunst.u,Reversi,Tetris,
  Bunt,Jahreszeiten,Doors,Pinguine.u,Rohre,Darken,Ebene,Bonus,
  Kolben,Walls,Baelle,Labyrinth,ColorShape,
  Unmoeglich,Elemente,Hormone,Himmel,
  Viecher,Memory,Labskaus,Schach,ReversiBRL,Go,Wachsen,Tennis

# All pictures which shall be included in distributions and get installed
# have to be mentioned somewhere in the level.descr. So here are the
# pictures which are not part of any level:
#   explosion.xpm     The animation when a blob explodes
#   dbgZiffern.xpm    The digits for debug output
#   pause.xpm         The icon when the game is paused
#   pktZiffern.xpm    The digits for the points
#   pktZiffern2.xpm   The digits for the points, too



### Level-Beschreibungen:
# Fr jeden Level kommt jetzt ein Abschnitt, der mit [Levelname] beginnt
# und folgendes enthlt:
# - pics gibt die Bildchen an, die in dem Level vorkommen
# - greypic ist das Bildchen vom grau-Dings
# - startpic gibt das Bildchen an, von dem ganz am Anfang schon was da ist
# - bubblespic gibt das Bildchen an, das hochblubbert (optional)
# Alle diese Bildchen knnen entweder Namen von xpm-Dateien sein oder
# Namen von Bildchen-Abschnitten in diese Datei (siehe weiter unten)
# - numexplode gibt an, wie viel Steine zusammen mssen, damit sie platzen
# - bgcolor gibt die Hintergrundfarbe an (RGB)
# - topcolor gibt die Farbe vom Rand an, der von oben runterkommt
# - toptime gibt die Zeit an, die der Rand zum runterkommen braucht
#   (in Spielschritten pro Pixel; ein Spielschritt sind 0,08 sec)
# - startdist gibt an, wie die start-pic-Bildchen am Anfang verteilt sind: Durch
#   Komma getrennt die Zeilen von oben nach unten
#   "." heit nix, A-Z und a-z sind die verschiedenen Versionen
# - textcolor ist die Farbe vom Text, der am Anfang vom Level da steht
# - chaingrass: 0 = Anfangsbildchen verschwinden bei jeder Explosion nebendran
#               1 = Anfangsbildchen verschwinden nur bei Kettenreaktion


include "globals.ld"

include "title.ld"
include "nasenkugeln.ld"
include "pfeile.ld"
include "hexkugeln.ld"
include "viecher.ld"
include "unterwasser.ld"
include "kunst.ld"
include "baelle.ld"
include "hormone.ld"
include "go.ld"
include "ebene.ld"
include "schach.ld"
include "wachsen.ld"
include "ascii.ld"
include "tiere.ld"
include "3d.ld"
include "doors.ld"
include "walls.ld"

# Berni
include "pinguine.ld"
include "bonus.ld"
include "letters.ld"
include "tetris.ld"
include "memory.ld"
include "colorshape.ld"
include "disco.ld"

# Mark
include "kolben.ld"
include "unmoeglich.ld"
include "maze.ld"
include "tennis.ld"
include "slime.ld"
include "silbergold.ld"
include "gold.ld"
include "zahn.ld"
include "bunt.ld"
include "labskaus.ld"
include "baender.ld"
include "reversi.ld"

# Jela
include "himmel.ld"
include "jahreszeiten.ld"
include "embroidery.ld"


# brl
include "elemente.ld"
include "wohnungen.ld"
include "darken.ld"
include "rohre.ld"
include "rohrpost.ld"
include "explosive.ld"
include "reversi_brl.ld"

# Simon
include "baggis.ld"

# Oti
#include "noten.ld"

# Peter
#include "cocktail.ld"



###############################################################################
# Previews von Mark:


Schema_0_Preview_Teil_1={
name=""
numexplode=1
toptime=10000
pics=schema0_preview
greypic=schema0_preview
startpic=schema0_preview
startdist="AAAA.AA.AA","AAAAAAAAAA","AA.AAA.A.A","AAAAA.AAAA",".AAAAAAAAA","A..A..A..A","AAAAA..AA.","A.A.AAAA.A","AA.AAA.AAA","A.AA.AAA.A","..A.A.AA.A","AAA.AAA..A","AA.A...AA.","..AAA..A.A","A..AA.A.AA"
}
Schema_0_Preview_Teil_2={
name=""
numexplode=1
toptime=10000
pics=schema0_preview
greypic=schema0_preview
startpic=schema0_preview
#startdist="..A.A.AA.A","AAA.AAA..A","AA.A...AA.","..AAA..A.A","A..AA.A.AA","A.AA.AAA..","AAAAA...A.",".AAA.AA.A.",A.....AA..",".AAA...A..","AA.A.AAAAA",".AA...AA..","AAA.AA.AAA","AAA.....A.","A.AA.AAAAA"
}
schema0_preview={
pics="Insert-Your-Picture-Here"
schema=0
}

